"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var servie_1 = require("servie");
var querystring_1 = require("querystring");
var servie_send_1 = require("servie-send");
var get_body_1 = require("get-body");
var graphql_server_core_1 = require("graphql-server-core");
var graphql_server_module_graphiql_1 = require("graphql-server-module-graphiql");
/**
 * Create a GraphQL server endpoint.
 */
function graphqlServie(options) {
    return function (req) {
        return __awaiter(this, void 0, void 0, function () {
            var method, query, _a, gqlResponse, err_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        method = req.method;
                        if (!(method === 'POST')) return [3 /*break*/, 2];
                        return [4 /*yield*/, get_body_1.parse(req.stream(), req.headers.object())];
                    case 1:
                        _a = _b.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        _a = querystring_1.parse(req.Url.query);
                        _b.label = 3;
                    case 3:
                        query = _a;
                        _b.label = 4;
                    case 4:
                        _b.trys.push([4, 6, , 7]);
                        return [4 /*yield*/, graphql_server_core_1.runHttpQuery([req], { method: method, options: options, query: query })];
                    case 5:
                        gqlResponse = _b.sent();
                        return [2 /*return*/, new servie_1.Response({
                                headers: {
                                    'Content-Type': 'application/json',
                                    'Content-Length': Buffer.byteLength(gqlResponse).toString()
                                },
                                body: gqlResponse
                            })];
                    case 6:
                        err_1 = _b.sent();
                        if (err_1.name !== 'HttpQueryError') {
                            throw err_1;
                        }
                        return [2 /*return*/, new servie_1.Response({
                                headers: err_1.headers,
                                status: err_1.statusCode,
                                body: err_1.message
                            })];
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
}
exports.graphqlServie = graphqlServie;
/**
 * Create a route for serving GraphiQL.
 */
function graphiqlServie(options) {
    return function (req) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, query, variables, operationName, graphiQLString;
            return __generator(this, function (_b) {
                _a = querystring_1.parse(req.Url.query), query = _a.query, variables = _a.variables, operationName = _a.operationName;
                graphiQLString = graphql_server_module_graphiql_1.renderGraphiQL({
                    endpointURL: options.endpointURL,
                    subscriptionsEndpoint: options.subscriptionsEndpoint,
                    query: String(query) || options.query,
                    variables: variables ? JSON.parse(String(variables)) : options.variables,
                    operationName: String(operationName) || options.operationName,
                    passHeader: options.passHeader
                });
                return [2 /*return*/, servie_send_1.send(req, graphiQLString, { type: 'text/html' })];
            });
        });
    };
}
exports.graphiqlServie = graphiqlServie;
//# sourceMappingURL=index.js.map